> For the complete documentation index, see [llms.txt](https://developers.polymath.network/polymesh-sdk-api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.polymath.network/polymesh-sdk-api-reference/docs-alpha/classes/api_entities_asset_transferrestrictions_transferrestrictionbase.transferrestrictionbase.md).

# api\_entities\_Asset\_TransferRestrictions\_TransferRestrictionBase.TransferRestrictionBase

[@polymeshassociation/polymesh-sdk](/polymesh-sdk-api-reference/docs-alpha/classes.md) / [Modules](/polymesh-sdk-api-reference/docs-alpha/modules.md) / [api/entities/Asset/TransferRestrictions/TransferRestrictionBase](/polymesh-sdk-api-reference/docs-alpha/modules-1/api_entities_asset_transferrestrictions_transferrestrictionbase.md) / TransferRestrictionBase

## Class: TransferRestrictionBase\<T>

[api/entities/Asset/TransferRestrictions/TransferRestrictionBase](/polymesh-sdk-api-reference/docs-alpha/modules-1/api_entities_asset_transferrestrictions_transferrestrictionbase.md).TransferRestrictionBase

Base class for managing Transfer Restrictions

### Type parameters

| Name | Type                                                                                                               |
| ---- | ------------------------------------------------------------------------------------------------------------------ |
| `T`  | extends [`TransferRestrictionType`](/polymesh-sdk-api-reference/docs-alpha/enums/types.transferrestrictiontype.md) |

### Hierarchy

* `Namespace`<[`Asset`](/polymesh-sdk-api-reference/docs-alpha/classes/api_entities_asset.asset.md)>

  ↳ **`TransferRestrictionBase`**

  ↳↳ [`Count`](/polymesh-sdk-api-reference/docs-alpha/classes/api_entities_asset_transferrestrictions_count.count.md)

  ↳↳ [`Percentage`](/polymesh-sdk-api-reference/docs-alpha/classes/api_entities_asset_transferrestrictions_percentage.percentage.md)

### Table of contents

#### Methods

* [addRestriction](#addrestriction)
* [get](#get)
* [removeRestrictions](#removerestrictions)
* [setRestrictions](#setrestrictions)

### Methods

#### addRestriction

▸ **addRestriction**(`args`, `opts?`): `Promise`<`TransactionQueue`<`BigNumber`, `BigNumber`, `unknown`\[]\[]>>

Add a Transfer Restriction of the corresponding type to this Asset

**`note`** the result is the total amount of restrictions after the procedure has run

**`note`** this method is of type [ProcedureMethod](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.proceduremethod.md), which means you can call [addRestriction.checkAuthorization](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.proceduremethod.md#checkauthorization) on it to see whether the signing Account and Identity have the required roles and permissions to run it

**Parameters**

| Name    | Type                                                                                        |
| ------- | ------------------------------------------------------------------------------------------- |
| `args`  | `AddRestrictionParams`<`T`>                                                                 |
| `opts?` | [`ProcedureOpts`](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.procedureopts.md) |

**Returns**

`Promise`<`TransactionQueue`<`BigNumber`, `BigNumber`, `unknown`\[]\[]>>

**Defined in**

[api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts:128](https://github.com/PolymathNetwork/polymesh-sdk/blob/31dfa0dc/src/api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts#L128)

***

#### get

▸ **get**(): `Promise`<`GetReturnType`<`T`>>

Retrieve all active Transfer Restrictions of the corresponding type

**`note`** there is a maximum number of restrictions allowed across all types. The `availableSlots` property of the result represents how many more restrictions can be added before reaching that limit

**Returns**

`Promise`<`GetReturnType`<`T`>>

**Defined in**

[api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts:163](https://github.com/PolymathNetwork/polymesh-sdk/blob/31dfa0dc/src/api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts#L163)

***

#### removeRestrictions

▸ **removeRestrictions**(`opts?`): `Promise`<`TransactionQueue`<`BigNumber`, `BigNumber`, `unknown`\[]\[]>>

Removes all Transfer Restrictions of the corresponding type from this Asset

**`note`** the result is the total amount of restrictions after the procedure has run

**`note`** this method is of type [NoArgsProcedureMethod](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.noargsproceduremethod.md), which means you can call [removeRestrictions.checkAuthorization](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.noargsproceduremethod.md#checkauthorization) on it to see whether the signing Account and Identity have the required roles and permissions to run it

**Parameters**

| Name    | Type                                                                                        |
| ------- | ------------------------------------------------------------------------------------------- |
| `opts?` | [`ProcedureOpts`](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.procedureopts.md) |

**Returns**

`Promise`<`TransactionQueue`<`BigNumber`, `BigNumber`, `unknown`\[]\[]>>

**Defined in**

[api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts:152](https://github.com/PolymathNetwork/polymesh-sdk/blob/31dfa0dc/src/api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts#L152)

***

#### setRestrictions

▸ **setRestrictions**(`args`, `opts?`): `Promise`<`TransactionQueue`<`BigNumber`, `BigNumber`, `unknown`\[]\[]>>

Sets all Transfer Restrictions of the corresponding type on this Asset

**`note`** the result is the total amount of restrictions after the procedure has run

**`note`** this method is of type [ProcedureMethod](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.proceduremethod.md), which means you can call [setRestrictions.checkAuthorization](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.proceduremethod.md#checkauthorization) on it to see whether the signing Account and Identity have the required roles and permissions to run it

**Parameters**

| Name    | Type                                                                                        |
| ------- | ------------------------------------------------------------------------------------------- |
| `args`  | `SetRestrictionsParams`<`T`>                                                                |
| `opts?` | [`ProcedureOpts`](/polymesh-sdk-api-reference/docs-alpha/interfaces/types.procedureopts.md) |

**Returns**

`Promise`<`TransactionQueue`<`BigNumber`, `BigNumber`, `unknown`\[]\[]>>

**Defined in**

[api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts:140](https://github.com/PolymathNetwork/polymesh-sdk/blob/31dfa0dc/src/api/entities/Asset/TransferRestrictions/TransferRestrictionBase.ts#L140)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.polymath.network/polymesh-sdk-api-reference/docs-alpha/classes/api_entities_asset_transferrestrictions_transferrestrictionbase.transferrestrictionbase.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
